<?php

// http://public-dns.tk/nameservers.json

$ns_list = json_decode(file_get_contents('nameservers.json'), true);

$results = array();
$count = count($ns_list);
foreach($ns_list as $i=>$ns)
{
  echo "$i/$count\n";
  if($ns['state'] == 'valid' && $ns['country_id'] == 'US')
  {
    $t = trim(`dig +time=1 @{$ns['ip']} google.com|grep 'Query time'`);
    if($t == '') continue;
    list(,$t) = explode(':', $t, 2);
    list($t) = explode(' ', trim($t), 2);
    $t = intval($t);
    $ns['time'] = $t;
    $results[] = $ns;
  }
}

function nscmp($a, $b)
{
  $a = $a['time'];
  $b = $b['time'];
  if($a == $b) return 0;
  return ($a < $b) ? 1 : -1;
}

usort($results, 'nscmp');

print_r($results);
