Name: unnamed
Version: 0.3
Release: 1%{?dist}
Summary: Unnamed DNS (Domain Name System) server
Group: System Environment/Daemons
License: GPLv2
URL: http://eder.us/projects/unnamed/
Source0: http://eder.us/projects/unnamed/unnamed-%{version}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: wget unzip

%description
Unnamed un-names undesirable names. It is modular with support for white/black
lists, catch-all resoultion, dns forwarders, local domains, rbls, country
resolution, and ipv6.

%prep
%setup -q

%build
make

%install
pwd
ls

rm -rf %{buildroot}

mkdir -p %{buildroot}/%{_initrddir}/
cp -a etc/init.d/unnamed %{buildroot}/%{_initrddir}/unnamed
mkdir -p %{buildroot}/%{_sysconfdir}/logrotate.d/
cp -a etc/logrotate.d/unnamed %{buildroot}/%{_sysconfdir}/logrotate.d/unnamed
mkdir -p %{buildroot}/%{_sysconfdir}/unnamed/
cp -a etc/unnamed.config %{buildroot}/%{_sysconfdir}/unnamed/unnamed.config
mkdir -p %{buildroot}/%{_datadir}/unnamed/
cp -a country.db %{buildroot}/%{_datadir}/unnamed/country.db
mkdir -p %{buildroot}/%{_sbindir}/
cp -a unnamed %{buildroot}/%{_sbindir}/unnamed
mkdir -p %{buildroot}/%{_libdir}/unnamed/
cp -a unnamed_catchall.so %{buildroot}/%{_libdir}/unnamed/unnamed_catchall.so
cp -a unnamed_forward.so %{buildroot}/%{_libdir}/unnamed/unnamed_forward.so
cp -a unnamed_local.so %{buildroot}/%{_libdir}/unnamed/unnamed_local.so
cp -a unnamed_rbl.so %{buildroot}/%{_libdir}/unnamed/unnamed_rbl.so
cp -a unnamed_country.so %{buildroot}/%{_libdir}/unnamed/unnamed_country.so
cp -a unnamed_ipv6_literal.so %{buildroot}/%{_libdir}/unnamed/unnamed_ipv6_literal.so
cp -a unnamed_version.so %{buildroot}/%{_libdir}/unnamed/unnamed_version.so

%clean
rm -rf %{buildroot}

%files

%defattr(-,root,root,-)

%{_initrddir}/unnamed
%config %{_sysconfdir}/logrotate.d/unnamed
%config(noreplace) %{_sysconfdir}/unnamed/unnamed.config
%{_datadir}/unnamed/country.db
%{_sbindir}/unnamed
%{_libdir}/unnamed/unnamed_catchall.so
%{_libdir}/unnamed/unnamed_forward.so
%{_libdir}/unnamed/unnamed_local.so
%{_libdir}/unnamed/unnamed_rbl.so
%{_libdir}/unnamed/unnamed_country.so
%{_libdir}/unnamed/unnamed_ipv6_literal.so
%{_libdir}/unnamed/unnamed_version.so

%doc
